/* XND_COR    Orientation, LP_Cor       */
static char *cvs_id =" $Id: xnd_cor.c,v 1.7 2006/04/13 10:13:27 berar Exp $ ";

#define  USE_BRAGG
#define  USE_VAR
#define  USE_EXPER
#define  USE_PHASE
#include "../xnd_def.h"
#include "../xnd_cah.h"

/* explicit values are required by some compilers .... */
#ifndef CONSTANTE_PURE
static float c_or[(MAX_ORIEN*(MAX_ORIEN+1))/2] =
{       1.0 ,
        -0.5, 1.5,
        3/8.0, -30/8.0, 35/8.0,
        -5/16.0,105/16.0,-315/16.0,231/16.0,
     35/128.0,-1260/128.0,6930/128.0,-12012/128.0,6435/128.0
        };
static float d_or[(MAX_ORIEN*(MAX_ORIEN-1))/2] =
{       1.5*2,
        -30/8.0*2, 35/8.0*24,
        105/16.0*2, -315/16.0*24, 231/16.0*720,
     -1260/128.0*2,6930/128.0*24,-12012/128.0*720,6435/128.0*40320.0
        };
#else
static float c_or[(MAX_ORIEN*(MAX_ORIEN+1))/2] =
{       1.0 ,
        -0.5, 1.5,
        0.375, -3.75, 4.375,
        -0.3125,6.5625,-19.6875,14.4375,
     0.2734375,-9.84375,54.140625,-93.84375,50.2734375
        };
static float d_or[(MAX_ORIEN*(MAX_ORIEN-1))/2] =
{       3.0,
        -7.5,105,
        13.125, -472.5, 10395.0,
     -19.6875,1299.375,-67567.5,2027025.0
        };
#endif
static char *T_coef_name[15]= { "S400","S040", "S004", "S220","S202", "S022", "S310","S301",
   "S130", "S031", "S103", "S013", "S211", "S121", "S112" };
/* ---------------------------------------------------------- */
/* Orientation    Pn(z^2) = 1/2^n/n! d^n/(dz)^n (z^2-1)^n     */
/* ---------------------------------------------------------- */
/*  p_orien    print the orientation function number n        */
/*             where cas = 0 (scale) or  1 (profile)          */        
/* ---------------------------------------------------------- */
void p_orien (P_(int) n, P_(int) cas)
#ifdef NO_PROTO
int n,cas;
#endif
{   int j,k,deg;
    deg = (cas==0) ? l_phase->c_orien[n] : l_phase->c_prof[n];
    if (deg >= 0)
    {    fprintf (list_fich," function #%d used for %s :\n P%d(z) =",n,
                cas==0? "prefered orientation" : "line profile orientation dependence",2*deg);
         tst_abort ((deg >= MAX_ORIEN || (cas==0 && deg==0)),
                "invalid polynomial choice");
        k = (deg*(deg+1))/2;
        for (j=0;j<=deg;j++)
        {    fprintf (list_fich," %+f ",c_or[k+j]);
             if (j!=0) fprintf (list_fich," z%d",2*j);
             }
        fprintf (list_fich," \n");
        }
     else  if (deg==-1 && cas==0) 
    {    fprintf (list_fich, " function #%d used for prefered orientation : March_Dollase function (G.cos(a)+sin(a)/G^2)-3/2\n");
        }
     else  if (deg<=-1 && deg>=-15 && cas==1) 
    {    fprintf (list_fich, " function #%d used for line profile dependence, tensorial expansion coef %s\n",
             n, T_coef_name[-deg-1]);
        }
     else  tst_abort (1, "invalid function declaration");
   }
/* ---------------------------------------------------------- */
/*  f_orien    calculates the orientation function number n   */
/*             where cas = 0 (scale) or  1 (profile)          */
/*      stores values, deriv in orien_val, orien_prof[0..2]   */
/* ---------------------------------------------------------- */
float f_orien (P_(int) n , P_(int) cas, P_(float) coef)
#ifdef NO_PROTO
int n;
int cas;
#endif
{   int   deg, p_ang;
    float ct, st, cp, sp;
    float z, z2;
    float v, *valeur;
    if (cas==0)
    {   valeur = orien_val + n * ORIEN;
        deg = l_phase->c_orien[n];
        }  
    else
    {   valeur = orien_prof + n * ORIEN_PROF;
        deg = l_phase->c_prof[n];
        }
    if (deg==0)
    {   *valeur = 1; *(valeur+1) = *(valeur+2) = 0;
	     return (1);
        }
    if (deg > 0 ||( cas==0 && deg==-1 ))
    {  p_ang = (cas ==0) ? n*ORIEN+ORIEN_ANG : n*PROF+PROF_ANG;
       ct = cos((v=RAD*var_valeur (p_ang)));
       st = sin(v);
       cp = cos((v=RAD*var_valeur (p_ang+1)));
       sp = sin(v);
       z2 = sqr ((z= ct * z_orien + st * ( cp * x_orien + sp * y_orien)));
       }
    if (deg > 0 )
    {  *valeur = poly_f(&z2, deg, &c_or[(deg*(deg+1))/2]);
       v =  poly_f (&z2, deg-1, &d_or[(deg*(deg-1))/2]) * z * RAD;
       *(valeur + 1) = - (st * z_orien + ct*(cp * x_orien + sp * y_orien)) * v;
       *(valeur + 2) = st * (- sp* x_orien + cp* y_orien) * v;
       return (coef * *valeur);
       }
    if (cas==0 && deg==-1)   /* March-Dollase orientation 8/3/2006 */
    {  float u= coef*coef*z2+(1-z2)/coef;
       float ret= pow(u,-1.50);
       *valeur = -1.5*ret/u*(2*coef*z2+1-z2);
       v =  -1.5*ret/u*2*(coef*coef-1/coef) * z * RAD;
       *(valeur + 1) = - (st * z_orien + ct*(cp * x_orien + sp * y_orien)) * v;
       *(valeur + 2) = st * (- sp* x_orien + cp* y_orien) * v;
       return (ret);
       }
    if (cas==1 && deg<0)   /* tensorial profile  8/3/2006 */
    {  float u;
       *(valeur + 0) =1.0;
       *(valeur + 1) =0;
       *(valeur + 2) =0;
       switch ( deg )
       {  case -1 : u = h_eff*h_eff*h_eff*h_eff; break;
          case -2 : u = k_eff*k_eff*k_eff*k_eff; break;
          case -3 : u = l_eff*l_eff*l_eff*l_eff; break;
          case -4 : u = h_eff*h_eff*k_eff*k_eff; break;
          case -5 : u = h_eff*h_eff*l_eff*l_eff; break;
          case -6 : u = k_eff*k_eff*l_eff*l_eff; break;
          case -7 : u = h_eff*h_eff*h_eff*k_eff; break;
          case -8 : u = h_eff*h_eff*h_eff*l_eff; break;
          case -9 : u = k_eff*k_eff*k_eff*h_eff; break;
          case -10 : u = k_eff*k_eff*k_eff*l_eff; break;
          case -11 : u = l_eff*l_eff*l_eff*h_eff; break;
          case -12 : u = l_eff*l_eff*l_eff*k_eff; break;
          case -13 : u = h_eff*h_eff*k_eff*l_eff; break;
          case -14 : u = k_eff*k_eff*h_eff*l_eff; break;
          case -15 : u = l_eff*l_eff*h_eff*k_eff; break;
          default : tst_abort (1, "invalid case in f_orien n %d cas %d deg %d ",n,cas,deg);
          }
       u = sqrt(u)/q;
       return (u);
       }
    tst_abort (1, "invalid case in f_orien n %d cas %d deg %d ",n,cas,deg);
    }
/* ---------------------------------------------------------- */
/*  orientation  calculates the orientation of the hkl line   */
/* ---------------------------------------------------------- */
void ini_orientation (P_(void))
{    if ( l_phase->n_orien==l_phase->nt_orien ) org_orien = 0;
     else org_orien = l_exper->number * l_phase->n_orien;
     }
/* ---------------------------------------------------------- */
/* 30/12/98 : change from H, K, L to h_eff, k_eff, l_eff */
void orientation (P_(void))
{    int i;
     act->orien = 1;
     if (l_phase->n_orien==0 && l_phase->n_prof==0) return;
     push_err_msg("orientation");
     z_orien = (0.5*(h_eff*g_ac+k_eff*g_bc) + l_eff*g_cc ) / sqrt(q*g_cc);
     y_orien = ( h_eff * (na_b * g_aa + 0.5 * nb_b * g_ab + 0.5 * nc_b * g_ac)
         + k_eff * (0.5 * na_b * g_ab + nb_b * g_bb + 0.5 * nc_b * g_bc)
         + l_eff * (0.5 * na_b * g_ac + 0.5 * nb_b * g_bc + nc_b * g_cc)) / s;
     x_orien = 1 - z_orien * z_orien - y_orien * y_orien;
     if (x_orien> 0) x_orien = sqrt (x_orien) ; else x_orien = 0;
     if (( h_eff  * g_aa + l_eff * g_ac)< 0) x_orien = - x_orien;
     var_init(l_phase->orien);
     for (i=org_orien;i<org_orien+l_phase->n_orien;i++)
     {  double coef = var_valeur(i*ORIEN);
        act->orien += f_orien(i, 0, coef );
        }
     pop_err_msg();
     }
/* ---------------------------------------------------------- */
/* this function return the correcting factor to intensities  */
/* assoc. with physical (polarisation) or geometrical factors */
/* variables abs_pl, abs_cyl, dcor_asym are set               */
/* they used in derivatives (xnd_der.c)                       */
void valcor (P_(void))
{    float sin_a, sin_b, mu_eff, ca, cb;
     float alpha_c, aa, bb;
     if (polar ) act->cor = ( 1.0 + polar * cos2_2t) / ( 1 + polar);
     else act->cor = 1.0;
     if ((l_exper->nature&EXPER_SINGLE_CRYSTAL)==0) 
     {   if ((l_phase->nature != PHASE_RDFPEAK) && (l_phase->nature != PHASE_RADIAL)) act->cor /= sin_t*sin_t*cos_t;
         }
     else
     {   if ((l_phase->nature != PHASE_RDFPEAK) && (l_phase->nature != PHASE_RADIAL)) act->cor /= sin_t*cos_t;
         }
     if (i_eclair && sin_t<eclair) act->cor *= sin_t/eclair;
     if (l_exper->techn == 0) return; 
     /* polarisation and lorentz cor are finished for standard sym reflex */
     var_init(l_exper->reglage);
     if (l_exper->techn) t_asym = var_valeur(4);
     switch (l_exper->techn/4)
     {  	case 0 :
           break;
	      case 1 : /* transmission */
         mu_eff= var_valeur(5);
         ca = - 1.7133 + 0.0368 * sin2_t;
         cb = 0.0927 + 0.375 * sin2_t;
         act->cor *= abs_cyl = exp( (ca + cb * mu_eff ) * mu_eff );
         abs_cyl *= ( ca + 2 *cb * mu_eff);
         mu_eff = var_valeur(6);
         act->cor *= abs_pl = exp (- mu_eff / sin_t);
         abs_pl /= - sin_t;
           break;
	      case 2 : /* fixed grazing incidence */
         alpha_c = var_valeur(5);
         mu_eff = var_valeur(6);
         aa = lambda*mu_eff/4/M_PI;
         bb = sqrt((sqrt(sqr(alpha_c*alpha_c-t_asym*t_asym)+4*aa*aa)+(alpha_c*alpha_c-t_asym*t_asym))/2);
         aa /= bb;
         act->cor *= 4*t_asym*t_asym/(sqr(aa+t_asym)+bb*bb);
         }
     switch (l_exper->techn)
     {  case 0 :
        case 4 : 
           return;
	     case 1 :
        case 5 : 
           sin_a = sin (RAD*(DTH/2-t_asym));
           sin_b = sin (RAD*(DTH/2+t_asym));
           dcor_asym = -RAD*(sin_a*cos(RAD*(DTH/2-t_asym))+sin_b*cos(RAD*(DTH/2+t_asym)));
           dcor_asym /= sin_b*(sin_a+sin_b);
           act->cor *=  sin_b / ( sin_a + sin_b );
			  return;
		  case 2 : 
		  case 3 : 
		  case 6 : 
        case 7 : 
           sin_a = sin (RAD*t_asym);
           sin_b = sin (RAD*(DTH-t_asym));
           dcor_asym = RAD*(sin_a*cos(RAD*t_asym)+sin_b*cos(RAD*(DTH-t_asym)));
           dcor_asym /= sin_b*(sin_a+sin_b);
           act->cor *= sin_b / ( sin_a + sin_b );
			  return;
        case 10 : 
        case 11 : 
           t_asym=2*t_asym-sqrt(t_asym*t_asym-alpha_c*alpha_c);
           sin_a = sin (RAD*t_asym);
           sin_b = sin (RAD*(DTH-t_asym));
           dcor_asym = RAD*(sin_a*cos(RAD*t_asym)+sin_b*cos(RAD*(DTH-t_asym)));
           dcor_asym /= sin_b*(sin_a+sin_b);
           act->cor *= sin_b / ( sin_a + sin_b );
			  return;
		  case 8 :  /* fixed grazing incidence */
           return;
		  }
     }
/* ---------------------------------------------------------- */

