static char *cvs_id =" $Id: xnd_dif.c,v 1.2 2004/07/30 08:04:00 berar Exp $ ";
/* XND_DIF     F_dif  */
/* ---------------------------------------------------------- */

#define USE_DIFDAT
#define USE_ATOM
#define USE_PHASE
#include "../xnd_def.h"
#include "../xnd_cah.h"
/* ---------------------------------------------------------- */
/* ---------------------------------------------------------- */

/* ---------------------------------------------------------- */
/* fonctions sont redirigees par valdif a l appel de la phase */
/* vers b_valdif, x_valdif, ub_valdif , ux_valdif, mb_valdif  */
/* t_valdif est commun au fonction par table                  */
/* ---------------------------------------------------------- */
static float t_valdif PROTO((TYPE_DIFDAT * xdif));
float b_valdif (P_(void))
{   return((l_atom->ndif)->coef);
    }
/* ---------------------------------------------------------- */
float x_valdif (P_(void))
{   return t_valdif( l_atom->xdif);
	 }
/* ---------------------------------------------------------- */
float ub_valdif (P_(void))
{   return t_valdif( l_atom->undif);
	 }
/* ---------------------------------------------------------- */
float ux_valdif (P_(void))
{   return t_valdif( l_atom->uxdif);
	 }
/* ---------------------------------------------------------- */
float mb_valdif (P_(void))
{   return t_valdif( l_atom->mdif);
	 }
/* ---------------------------------------------------------- */
static float t_valdif (P_(TYPE_DIFDAT *) xdif)
#ifdef NO_PROTO
TYPE_DIFDAT * xdif;
#endif
{   int i;
    float *coef;
    float *act;
    float qq;

    act = &xdif->act;
    if (xdif->s == s) return *act;
    coef = &(xdif)->coef;
    xdif->s=s;
    switch (xdif->cas)
    {   case 1 :  /* interpolation */
	        i = floor(0.5*s / coef[0]);
	        if (i<xdif->tot) 
		*act = coef[i]+(0.5*s-i*coef[0])*(coef[1+i]-coef[i])/coef[0] ;
		else *act = 0;
		break;
	case 2 :  /* TIC  Ae-as2 + B e-bs2 +.... + E */
		 *act=coef[xdif->tot-1];
		 qq = 0.25 * q;
		 for (i=0;i<xdif->tot-1;i+=2)
		 *act += coef[i] * exp (-qq*coef[i+1]);
		 break;
		 }
	return *act;
    }

/* ---------------------------------------------------------- */
/* ---------------------------------------------------------- */
void ato_anodif(P_(void))
{   int i;
	 float *coef;

    if (l_atom->adif == NULL) return;
    coef = l_atom->adif->coef;
    if (coef[0] != lambda)
    {     coef[0]=lambda;
          coef[1]=coef[2]=0;
    	  for (i=0;i<(l_atom->adif)->tot;i++)
    	  if (fabs(lambda-coef[3+3*i])<EPSILON_ANOMAL)
    	  {	coef[1] = coef[4+3*i];
    	  	coef[2] = coef[5+3*i];
    	  	return;
    	  	}
    }     }
/* ---------------------------------------------------------- */

void ini_anodif (P_(void))
{   int i,j;

    for (i=0,l_atom=l_phase->atom;i<l_phase->n_atom;i++,l_atom++)
        ato_anodif();
    for (j=0;j<l_phase->nb_bloc;j++)
      for (i=0,l_atom=l_phase->bl_relat[j];i<l_phase->bl_atom[j];i++,l_atom++)
        ato_anodif();
    }

/* ---------------------------------------------------------- */

static float imag;
float anodif (P_(void))
{   float *coef;
    if (l_atom->adif == NULL)
    {	imag = 0;
    	return (0);
    	}
    coef = l_atom->adif->coef;
    imag = coef[2];	
    return(coef[1]);
	 }

float anodif_b (P_(void))
{       return(imag);
    }
/* ---------------------------------------------------------- */
/* ---------------------------------------------------------- */





