static char *cvs_id =" $Id: xnd_mod.c,v 1.2 2004/07/30 08:04:15 berar Exp $ ";
/* XND_MOD.C   traitements specif des struct modules ou magnetiques */

#define USE_BRAGG
#define USE_VAR
#define USE_SYM
#define USE_SETS
#define USE_MODUL
#define USE_PHASE
#define USE_PSEUDO
#define USE_ATOM
#include "../xnd_def.h"
#include "../xnd_cah.h"
#include "xnd_moh.h"
/* ---------------------------------------------------------- */
extern TYPE_SYMGRP * nucl_symgrp;
TYPE_MODUL * current_modul;
TYPE_SATEL * current_satel;
void big_cell PROTO((int z_ratio, TYPE_SYMGRP *l_sym, TYPE_SYMGRP *l_sym4));
/* ---------------------------------------------------------- */
/* store in q_eff (h_eff, k_eff, l_eff) the real value        */
/* ---------------------------------------------------------- */
void hkl_modul(P_(void))
{    int i, j;

     for (j=0; j<3; j++) q_eff[j] = act->h[j] ;
     if (l_phase->vector == NULL) return;
     var_init(l_phase->vector);
     for (j=0; j<3; j++)
     {   for (i=0; i < current_modul->size; i++)
            q_eff[j] += act->h[3+i] * var_valeur(j+3*i);
         }
     }
/* ---------------------------------------------------------- */
/* initialization of the derivatives for modulation vector    */
/* called by ini_d_metric for modulated phases                */
void ini_d_vector (P_(float) dt_dq)
#ifdef NO_PROTO
float dt_dq;
#endif
{    int i, m;
     if (l_phase->vector == NULL) return;
     var_init(l_phase->vector);
     for (i=m=0; i < current_modul->size; i++, m+= 3)
     {  vector_deriv[m] = dt_dq  * act->h[3+i] * /* current_satel->hkl_sat[i] */ 
                ( 2 * h_eff * g_aa + k_eff * g_ab + l_eff * g_ac);
        vector_deriv[m+1] = dt_dq  * act->h[3+i] * /*current_satel->hkl_sat[i] */
                ( h_eff * g_ab + 2 * k_eff * g_bb + l_eff * g_bc);
        vector_deriv[m+2] = dt_dq  * act->h[3+i] * /*current_satel->hkl_sat[i] */
                ( h_eff * g_ac + k_eff * g_bc + 2 * l_eff * g_cc);
        }
    }
/* ---------------------------------------------------------- */
void genget_mod (P_(void))
{   int i, j, n;
	 push_err_msg("genget_mod(xnd_mod.c)");
    current_modul = l_pseudo_phase->modul;
    current_satel = l_pseudo_phase->satel;
    vector_deriv = NULL;
    if (l_phase->vector && l_phase->vector->dim >=1)
          vector_deriv = (float *) tst_alloc (3 * current_modul->size,
              sizeof(float), "vector derivatives");
    if (*fhkl_eff == fhkl_incmod) alloc_incmod();
	  
    if (l_pseudo_phase->sets->nb_hkl > 0)  get_hkl();
	 else for (i=j=0; i<l_pseudo_phase->satel->n_ind;i++)
    {  for (n=0; n<current_modul->size;n++,j++)
		    act->h[3+n]=current_satel->hkl_sat[j];
        gen_hkl();
        }
    if (*fhkl_eff == fhkl_incmod) free_incmod();
    if (vector_deriv) free (vector_deriv);
    pop_err_msg();
    }
/* ---------------------------------------------------------- */
void genget_mag (P_(void))
{   push_err_msg("genget_mag(xnd_mod.c)");
    if ( l_pseudo_phase->ps_case == PS_MAGNET && dif_nature != EXPER_NM) return;
	 nucl_symgrp = l_pseudo_phase->phase->symgrp;
    current_modul = l_pseudo_phase->modul;
    if (l_pseudo_phase->sets->nb_hkl > 0)   get_hkl();
    else if (l_pseudo_phase->sets->nb_hkl == 0) gen_hkl();
    pop_err_msg();
    }
/* ---------------------------------------------------------- */
void big_cell (P_(int) z_ratio, P_(TYPE_SYMGRP) *l_sym, P_(TYPE_SYMGRP) *l_sym4)
{   float xo[3], xm[6], ym[6], x[3], y[3], c[5][3];
    float *sym_coef;
    double z;
    int i, j, k, t, iz;
    z = 2*M_PI/z_ratio;
    t = 1;
    memset (&c[0][0],0, 15*sizeof(float));
    switch (current_symgrp->bravais)
    {   case 'A' :  c[1][1]=c[1][2]=0.5;  t=2; break;
        case 'B' :  c[1][0]=c[1][2]=0.5;  t=2; break;
        case 'C' :  c[1][0]=c[1][1]=0.5;  t=2; break;
        case 'I' :  c[1][0]=c[1][1]=c[1][2]=0.5;  t=2; break;
        case 'F' :  c[1][1]=c[1][2]=0.5;
                    c[2][0]=c[2][2]=0.5;
                    c[3][0]=c[3][1]=0.5;  t=4; break;
        }
    var_init(l_atom->x);
    for (j=0; j<3; j++) xo[j] = var_valeur(j);
    var_init(l_atom->modul);
    for (j=0; j<6; j++) xm[j] = var_valeur(j);
    for (i=0, sym_coef = l_sym->coef; i < l_sym->nops; i++, sym_coef += 12)
    {   for (j=0; j<3; j++) x[j] = sym_coef[j] * xo[0] + sym_coef[j+3] * xo[1]
	                         + sym_coef[j+6] * xo[2] + sym_coef[j+9];
        for (j=0; j<3; j++) ym[2*j] = sym_coef[j] * xm[0] + sym_coef[j+3] * xm[2]
	                         + sym_coef[j+6] * xm[2];
        for (j=0; j<3; j++) ym[2*j+1] = sym_coef[j] * xm[1] + sym_coef[j+3] * xm[3]
	                         + sym_coef[j+6] * xm[5];
	for (j=0; j<6; j++) ym[2*j] *=  l_sym4->coef[2*i];
        if ( fabs( 2*l_sym4->coef[2*i+1] - 1) < 0.01) for (j=0; j<6; j++) ym[j] = -ym[j];
/* if (l_atom->n_modul) fprintf(list_fich, "(%6.3f %6.3f %6.3f) (%6.3f %6.3f %6.3f)(%6.3f %6.3f %6.3f)\n",
 x[0],x[1],x[2], ym[0],ym[2],ym[4],ym[1],ym[3],ym[5]);  */
        for(iz=0; iz<z_ratio; iz++)
	{  fprintf(list_fich, " %s %2d sym %d", l_atom->nom, iz, i);
	   for (k=0; k<t; k++) 
	   {  for (j=0; j<3; j++)
	      {  y[j] = 0;
            if (l_atom->n_modul)  y[j] += ym[2*j]*sin((iz+x[2])*z) + ym[2*j+1]*cos((iz+x[2])*z);
		 }
	      fprintf(list_fich, " (%6.3f %6.3f %6.3f)", x[0]+y[0]+c[k][0],
	              x[1]+y[1]+c[k][1], (x[2]+y[2]+c[k][2]+iz)/z_ratio);
	      }
           if ( l_sym->centro)  
	   {  if ( t > 2 ) fprintf(list_fich, "\n %s %2d", l_atom->nom, iz);
              fprintf(list_fich, " inv %d", i);
              for (k=0; k<t; k++) fprintf(list_fich, " (%6.3f %6.3f %6.3f)", -x[0]+y[0]+c[k][0], -x[1]+y[1]+c[k][1], (-x[2]+y[2]+c[k][2]+iz)/z_ratio);
              }
           fprintf(list_fich, "\n");
           }
        }
    fprintf(list_fich, "\n");
    }
/* ---------------------------------------------------------- */
/* ---------------------------------------------------------- */


