static char *cvs_id =" $Id: xnd_sym4.c,v 1.2 2004/07/30 08:04:16 berar Exp $ ";
/* XND_SYM4.C multiplicite, holoedre, extinction */

#define  USE_BRAGG
#define USE_MODUL
#define USE_SYM
#define USE_PHASE
#define USE_PSEUDO
#include "../xnd_def.h"
/* ---------------------------------------------------------- */
/*  following functions are used in case of modulated phases  */
/* ---------------------------------------------------------- */
/*     -  4D lattice extinction rules                         */
/*     -  4D lattice powder multiplicity                      */
/* ---------------------------------------------------------- */
/* ---------------------------------------------------------- */
/* extinction rules for 4D centering    */
#define M act->h[3]
/* allowed hkl lines return 0, others 1 */
int P4_extinction (P_(void))
{   return 0;
    }
/*  qrat = 1/2 0 0 */
int A4A_extinction (P_(void))
{   return (abs(H+M)%2 + abs((K+L)%2));
    }
int A4P_extinction (P_(void))
{   return ((H+M)%2);
    }
/*  qrat = 0 1/2 0 */
int B4B_extinction (P_(void))
{   return (abs(K+M)%2 + abs((H+L)%2));
    }
int B4P_extinction (P_(void))
{   return ((K+M)%2);
    }
/*  qrat = 0 0 1/2 */
int C4C_extinction (P_(void))
{   return (abs(L+M)%2 + abs((H+K)%2));
    }
int C4P_extinction (P_(void))
{   return ((L+M)%2);
    }
/*  vecteur q entier */
/*  qrat = 1 0 0   */
int L4A_extinction (P_(void))
{   return ((K+L)%2);
    }
int L4B_extinction (P_(void))
{   return ((L+H+M)%2);
    }
int L4C_extinction (P_(void))
{   return ((H+K+M)%2);
    }
int L4F_extinction (P_(void))
{   return (abs((H+K+M)%2) + abs((K+L)%2));
    }
int L4I_extinction (P_(void))
{   return ((H+K+L+M)%2);
    }
int L4P_extinction (P_(void))
{   return (0);
    }
	 /*  qrat = 0 1 0  */
int M4A_extinction (P_(void))
{   return ((K+L+M)%2);
    }
int M4B_extinction (P_(void))
{   return ((L+H)%2);
    }
int M4C_extinction (P_(void))
{   return ((H+K+M)%2);
    }
int M4F_extinction (P_(void))
{   return (abs((K+L+M)%2) + abs((H+L)%2));
    }
int M4I_extinction (P_(void))
{   return ((H+K+L+M)%2);
    }
int M4P_extinction (P_(void))
{   return (0);
    }
	 /*  qrat = 0 0 1 */
int N4A_extinction (P_(void))
{   return ((K+L+M)%2);
    }
int N4B_extinction (P_(void))
{   return ((L+H+M)%2);
    }
int N4C_extinction (P_(void))
{   return ((H+K)%2);
    }
int N4F_extinction (P_(void))
{   return (abs((L+H+M)%2) + abs((H+K)%2));
    }
int N4I_extinction (P_(void))
{   return ((H+K+L+M)%2);
    }
int N4P_extinction (P_(void))
{   return (0);
    }
/*  qrat = 1 1 0   */
int LM4A_extinction (P_(void))
{   return ((K+L+M)%2);
    }
int LM4B_extinction (P_(void))
{   return ((L+H+M)%2);
    }
int LM4C_extinction (P_(void))
{   return ((H+K)%2);
    }
int LM4F_extinction (P_(void))
{   return (abs((H+K)%2) + abs((K+L+M)%2));
    }
int LM4I_extinction (P_(void))
{   return ((H+K+L)%2);
    }
int LM4P_extinction (P_(void))
{   return (0);
    }
	 /*  qrat = 0 1 1  */
int MN4A_extinction (P_(void))
{   return ((K+L)%2);
    }
int MN4B_extinction (P_(void))
{   return ((L+H+M)%2);
    }
int MN4C_extinction (P_(void))
{   return ((H+K+M)%2);
    }
int MN4F_extinction (P_(void))
{   return (abs((K+L)%2) + abs((H+L+M)%2));
    }
int MN4I_extinction (P_(void))
{   return ((H+K+L+M)%2);
    }
int MN4P_extinction (P_(void))
{   return (0);
    }
	 /*  qrat = 1 0 1 */
int LN4A_extinction (P_(void))
{   return ((K+L+M)%2);
    }
int LN4B_extinction (P_(void))
{   return ((L+H)%2);
    }
int LN4C_extinction (P_(void))
{   return ((H+K+M)%2);
    }
int LN4F_extinction (P_(void))
{   return (abs((L+H)%2) + abs((H+K+M)%2));
    }
int LN4I_extinction (P_(void))
{   return ((H+K+L)%2);
    }
int LN4P_extinction (P_(void))
{   return (0);
    }
	 /*  qrat = 0 1/2 1/2  */
int U4O_extinction (P_(void))
{   return ((K+M)%2 + (L+M)%2);
    }
int U4Q_extinction (P_(void))
{   return ((K+L+M)%2);
    }
/*  qrat = 1/2 0 1/2 */
int V4O_extinction (P_(void))
{   return ((H+M)%2 + (L+M)%2);
    }
int V4Q_extinction (P_(void))
{   return ((H+L+M)%2);
    }
/*  qrat = 1/2 1/2 0 */
int W4O_extinction (P_(void))
{   return ((H+M)%2 + (K+M)%2);
    }
int W4Q_extinction (P_(void))
{   return ((H+K+M)%2);
    }
/*  qrat = 1/3 1/3 0 */
int R4_extinction (P_(void))
{   return ((H-K-M)%3);
    }
/* ---------------------------------------------------------- */
/* return function used by for ini_4D_extinction */
static int ini_4D_error(void)
{  verbose_printf ("error : non supported extiction setting\n");
   pop_err_msg();
   return 1;
   }
static int ini_4D_ok( char *txt)
{  fprintf(list_fich," extinction %s\n", txt);
   pop_err_msg();
   return 0;
   }
/* ---------------------------------------------------------- */
int ini_4D_extinction(P_(TYPE_PSEUDO *) local_pseudo)
{  double dqrat = 0;
   int i, qrat_sq;
   TYPE_SYMGRP * current_symgrp = local_pseudo->phase->symgrp;
   for (i=0;i<3;i++)
     dqrat += current_modul->center_4d[i]*current_modul->center_4d[i];
   qrat_sq = 0.5 + 36 * dqrat;
   push_err_msg("ini_4D_extinction (xnd_sym4.c)");
   if (qrat_sq == 0)
	{      return ini_4D_ok("3D_extinction used");
		 }
   if (qrat_sq == 8)
	{   /*  qrat =  1/3 1/3 0 */
       local_pseudo->extinction =  R4_extinction;
       return ini_4D_ok("R4");
		 }
  if (qrat_sq == 9)
  {   /*  qrat = 1/2 0 0,  0 1/2 0 or 0 0 1/2 */
      if ( current_modul->center_4d[0] != 0 )
        switch (current_symgrp->bravais)
      {   case 'A' : local_pseudo->extinction = A4A_extinction;
                     return ini_4D_ok("A4A");
          case 'P' : local_pseudo->extinction = A4P_extinction;
                     return ini_4D_ok("A4P");
          default  : return ini_4D_error();
          }
      if ( current_modul->center_4d[1] != 0 )
        switch (current_symgrp->bravais)
      {   case 'B' : local_pseudo->extinction = B4B_extinction;
                     return ini_4D_ok("B4B");
          case 'P' : local_pseudo->extinction = B4P_extinction;
                     return ini_4D_ok("B4P");
          default  : return ini_4D_error();
               }
      switch (current_symgrp->bravais)
      {   case 'C' : local_pseudo->extinction = C4C_extinction;
                     return ini_4D_ok("C4C");
          case 'P' : local_pseudo->extinction = C4P_extinction;
                     return ini_4D_ok("C4P");
          default  : return ini_4D_error();
          }
       }
   if (qrat_sq == 18)
   {   /*  qrat = 0 1/2 1/2 ,  1/2 0 1/2 or 1/2 0 0 */
       if ( current_modul->center_4d[0] == 0 )
         switch (current_symgrp->systeme)
       {   case 'O' : local_pseudo->extinction = U4O_extinction;
                      return ini_4D_ok("U4O");
           case 'Q' : local_pseudo->extinction = U4Q_extinction;
                      return ini_4D_ok("U4Q");
           default  : return ini_4D_error();
           }
       if ( current_modul->center_4d[1] == 0 )
         switch (current_symgrp->systeme)
       {   case 'O' : local_pseudo->extinction = V4O_extinction;
                      return ini_4D_ok("V4O");
           case 'Q' : local_pseudo->extinction = V4Q_extinction;
                      return ini_4D_ok("V4Q");
           default  : return ini_4D_error();
           }
       switch (current_symgrp->bravais)
       {   case 'O' : local_pseudo->extinction = W4O_extinction;
                      return ini_4D_ok("W4O");
           case 'Q' : local_pseudo->extinction = W4Q_extinction;
                      return ini_4D_ok("W4Q");
           default  : return ini_4D_error();
           }
       }
   if (qrat_sq == 36)
   {   /*  qrat = 1 0 0  ,  0 1 0 or 0 0 1 */
       if ( current_modul->center_4d[1] == 0 && current_modul->center_4d[2] == 0)
         switch (current_symgrp->bravais)
       {   case 'A' : local_pseudo->extinction = L4A_extinction;
                           return ini_4D_ok("L4A");
           case 'B' : local_pseudo->extinction = L4B_extinction;
                           return ini_4D_ok("L4B");
           case 'C' : local_pseudo->extinction = L4C_extinction;
                           return ini_4D_ok("L4C");
           case 'I' : local_pseudo->extinction = L4I_extinction;
                           return ini_4D_ok("L4I");
           case 'F' : local_pseudo->extinction = L4F_extinction;
                           return ini_4D_ok("L4F");
           case 'P' : local_pseudo->extinction = L4P_extinction;
                           return ini_4D_ok("L4P");
           default  : return ini_4D_error();
           }
       if ( current_modul->center_4d[0] == 0 && current_modul->center_4d[2] == 0)
         switch (current_symgrp->bravais)
       {   case 'A' : local_pseudo->extinction = M4A_extinction;
                           return ini_4D_ok("M4A");
           case 'B' : local_pseudo->extinction = M4B_extinction;
                           return ini_4D_ok("M4B");
           case 'C' : local_pseudo->extinction = M4C_extinction;
                           return ini_4D_ok("M4C");
           case 'I' : local_pseudo->extinction = M4I_extinction;
                           return ini_4D_ok("M4I");
           case 'F' : local_pseudo->extinction = M4F_extinction;
                           return ini_4D_ok("M4F");
           case 'P' : local_pseudo->extinction = M4P_extinction;
                           return ini_4D_ok("M4P");
           default  : return ini_4D_error();
           }
      if ( current_modul->center_4d[0] == 0 && current_modul->center_4d[1] == 0)
        switch (current_symgrp->bravais)
      {   case 'A' : local_pseudo->extinction = N4A_extinction;
                           return ini_4D_ok("N4A");
          case 'B' : local_pseudo->extinction = N4B_extinction;
                           return ini_4D_ok("N4B");
          case 'C' : local_pseudo->extinction = N4C_extinction;
                           return ini_4D_ok("N4C");
          case 'I' : local_pseudo->extinction = N4I_extinction;
                           return ini_4D_ok("N4I");
          case 'F' : local_pseudo->extinction = N4F_extinction;
                           return ini_4D_ok("N4F");
          case 'P' : local_pseudo->extinction = N4P_extinction;
                           return ini_4D_ok("N4P");
          default  : return ini_4D_error();
          }
      }
   if (qrat_sq == 72)
   {  if ( current_modul->center_4d[0] == 0 )
        switch (current_symgrp->bravais)
      {   case 'A' : local_pseudo->extinction = MN4A_extinction;
                           return ini_4D_ok("MN4A");
          case 'B' : local_pseudo->extinction = MN4B_extinction;
                           return ini_4D_ok("MN4B");
          case 'C' : local_pseudo->extinction = L4C_extinction;
                           return ini_4D_ok("MN4C");
          case 'I' : local_pseudo->extinction = MN4I_extinction;
                           return ini_4D_ok("MN4I");
          case 'F' : local_pseudo->extinction = MN4F_extinction;
                           return ini_4D_ok("MN4F");
          case 'P' : local_pseudo->extinction = MN4P_extinction;
                           return ini_4D_ok("MN4P");
          default  : return ini_4D_error();
          }
      if ( current_modul->center_4d[1] == 0 )
       switch (current_symgrp->bravais)
      {   case 'A' : local_pseudo->extinction = LN4A_extinction;
                           return ini_4D_ok("LN4A");
          case 'B' : local_pseudo->extinction = LN4B_extinction;
                           return ini_4D_ok("LN4B");
          case 'C' : local_pseudo->extinction = LN4C_extinction;
                           return ini_4D_ok("LN4C");
          case 'I' : local_pseudo->extinction = LN4I_extinction;
                           return ini_4D_ok("LN4I");
          case 'F' : local_pseudo->extinction = LN4F_extinction;
                           return ini_4D_ok("LN4F");
          case 'P' : local_pseudo->extinction = LN4P_extinction;
                           return ini_4D_ok("LN4P");
          default  : return ini_4D_error();
          }
      if ( current_modul->center_4d[2] == 0 )
        switch (current_symgrp->bravais)
      {   case 'A' : local_pseudo->extinction = LM4A_extinction;
                           return ini_4D_ok("LM4A");
          case 'B' : local_pseudo->extinction = LM4B_extinction;
                           return ini_4D_ok("LM4B");
          case 'C' : local_pseudo->extinction = LM4C_extinction;
                           return ini_4D_ok("LM4C");
          case 'I' : local_pseudo->extinction = LM4I_extinction;
                           return ini_4D_ok("LM4I");
          case 'F' : local_pseudo->extinction = LM4F_extinction;
                           return ini_4D_ok("LM4F");
          case 'P' : local_pseudo->extinction = LM4P_extinction;
                           return ini_4D_ok("LM4P");
          default  : return ini_4D_error();
          }
      }
   return ini_4D_error();
   }
/* ---------------------------------------------------------- */
/* ---------------------------------------------------------- */
