static char *cvs_id =" $Id: xnd_prlo.c,v 1.1 2004/07/30 08:04:25 berar Exp $ ";
/* XND_PRLO.C    lorentz profile function */

#define  USE_BRAGG
#include "xnd_t_cplx.h"
#include "xnd_prof.h"
/* =========================================================== */
/* lorentz profile function, peak position derivative       */
/* lorentz_width and 2*gauss_square_width derivatives       */
/* derivatives used the stored values : w_y, dt2            */
/* ----------------------------------------------------------- */
float lorentz_profil (P_(void))
{   prof_dt2 = dt * dt + y_coef;
	 w_y = j_coef / prof_dt2;
    return (w_y);
    }
/* ----------------------------------------------------------- */
float lorentz_dprof_dt (P_(void))
{   return (2 * dt * w_y / prof_dt2 );
    }
/* ----------------------------------------------------------- */
float lorentz_dprof_dl (P_(void))
{   return ( w_y * ( 1 / W_L - 0.5 * W_L / prof_dt2) );
    }
/* ----------------------------------------------------------- */
int ini_lorentz (P_(void))
{   float   larg;
    larg = W_L / 2;
    y_coef = larg*larg;
    j_coef =  M_1_PI * I_C * larg;
    if (j_coef/y_coef < 0.5*minimum) return (0);
    influence = 2 * larg;
    if (j_coef/y_coef < minimum ) influence *=0.5;
    w_x = 0;
    prof_case = 2;
    return (1);
    }
/* ----------------------------------------------------------- */
/* for analytical convolution                                  */
/* ----------------------------------------------------------- */
float a_lorentz_profil (P_(void))
{   fcomplex xx;
    prof_dt2 = dt * dt + y_coef;
	 w_y = j_coef / prof_dt2;
    return (w_y);
    }
/* ----------------------------------------------------------- */
float a_lorentz_dprof_dt (P_(void))
{   return (2 * dt * w_y / prof_dt2 );
    }
/* ----------------------------------------------------------- */
float a_lorentz_dprof_dl (P_(void))
{   return ( w_y * ( 1 / W_L - 0.5 * W_L / prof_dt2) );
    }
/* ----------------------------------------------------------- */
