static char *cvs_id =" $Id: xnd_rdif.c,v 1.3 2004/07/30 08:04:39 berar Exp $ ";
/* XND_RDIF.C    lecture tables de diffusion */

#define USE_VAR
#define USE_DIFDAT
#include "../xnd_def.h"
#include "xnd_rdh.h"
#include <string.h>

/* ------------------------------------------------------------------ */
void put_dif(P_(TYPE_DIFDAT *) difdat, P_(FILE *) file)
#ifdef NO_PROTO
TYPE_DIFDAT *difdat;
FILE * file;
#endif
{   int i;
    float *l_coef;
    char prefix = ' ';
    if (difdat->cas == 1 )
    switch (difdat->nom[0])
    {    case '_' : case '-' :
         case '$' : 
         case '&' : prefix = ' '; break;
         default :  prefix ='*';
      }
     fprintf(file," %c%s ", prefix, difdat->nom);
    l_coef = &difdat->coef;
    if (difdat->cas==1) 
    {    fprintf(file," %d   %f\n      ",difdat->tot, *l_coef);
         l_coef++;
         }
     for (i=0;i<difdat->tot;i++,l_coef++)
          fprintf(file," %9.5f%s",*l_coef,i%5==4?"\n      ":"");
    if (i%5!=0) fprintf(file,"\n");
	 fprintf(file,"\n");
    }

/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */

TYPE_DIFDAT *lecture_dif (P_(FILE *) file, P_(TYPE_DIFDAT *) mem)
#ifdef NO_PROTO
FILE *file;
TYPE_DIFDAT *mem;
#endif
{   char ligne[60];
    char cas, *nom;
    int  i,n,s,tot,r;
    float  *l_coef;
    TYPE_DIFDAT *l_dif;
    char *buf, buffer [200];
	 
	 do 
	 {  fscanf(file," %c",ligne);
	    if (ligne[0]=='#') fgets(buffer, sizeof(buffer)-1, file);
	    } while (ligne[0]=='#');
    ligne[1]=0;
	 do
	 {  cas = fgetc(file);
	    if ( cas != ' ' &&  cas != '\n' &&  cas != '\r')
		 {   ligne[strlen(ligne)+1]=0;
		     ligne[strlen(ligne)]=cas;
		     } else cas = ' ';
		 }	 while (cas !=' ');  
    strup (ligne);
    if (isdigit(ligne[0]) )  /* neutron length */
    {   nom = ligne;
        cas = 0;
        n = tot = 1;
        }
   else if (ligne[0]=='_' || ligne[0]=='*'|| ligne[0]=='&'|| ligne[0]=='$')
   {   if (ligne[0]=='*') nom = ligne+1; else nom = ligne;
       cas = 1;
       fscanf (file," %d",&tot);
       n=1+tot;
       }
    else if ( ligne[0]=='-')  /* magnetic jo in TIC values */
    {  nom = ligne;
       cas = 2;
       n =tot=7;
       }
    else    /* standart TIC values */
    {   nom = ligne;
        cas = 2;
        n=tot = 9;
        }
   s = sizeof(TYPE_DIFDAT)+n*sizeof(float);
   if (mem == NULL) l_dif = (TYPE_DIFDAT *)tst_alloc(1,s,"difdat");
	else l_dif = mem;
   strcpy (l_dif->nom,nom);
   l_dif->tot = tot;
   l_dif->cas = cas;
   l_coef= &l_dif->coef;
    for (i=0;i<n;i++,l_coef++) 
	 {   fscanf(file," %f",l_coef);
	     buf += r;
		  }
    n_dif++;    
    return (l_dif);
    }

/* ------------------------------------------------------------------ */

TYPE_DIFDAT *get_dif (P_(char *) modele,P_(int) fatal)
#ifdef NO_PROTO
char *modele;
int fatal;
#endif
{  TYPE_DIFDAT **l_dif;
   TYPE_DIFDAT *mem;
   FILE   *dif_fich;
	char   filename[200];
   int i, n;

   push_err_msg("get_dif(xnd_rdif.c)");
   strup(modele);
   for (i=0,l_dif=lect->difdat; i<n_dif; i++,l_dif++)
   {  if (strcmp((*l_dif)->nom,modele)==0) 
      {  if (lect->prt_dif>=4) 
	      {   fprintf(list_fich,"    dif =");
	          put_dif(*l_dif, list_fich);
	          }
          pop_err_msg();
	       return(*l_dif);
	       }
       }
    dif_fich = fopen (DIF_FILE,"r");
	 if ( ! dif_fich )
	 {  dif_fich = tst_open (lect->dif_name,"r","open diffusion file");
	    strcpy(filename,lect->dif_name);
	    } else strcpy(filename,DIF_FILE);
    tst_abort ((n_dif>MAX_DIF),"Dim table dif");
    i = sizeof(TYPE_DIFDAT)+100*sizeof(float);
    mem = (TYPE_DIFDAT *)tst_alloc(1,i,"difdat");
    do
    {  lecture_dif(dif_fich, mem);
       if (strcmp(mem->nom,modele)==0)
       {  n = (mem->cas==1) ? mem->tot+1 : mem->tot;
		    i = sizeof(TYPE_DIFDAT)+n*sizeof(float);
          *l_dif = (TYPE_DIFDAT *)tst_alloc(1,i,"difdat");
          memcpy(*l_dif, mem, i);
			 if (lect->prt_dif>1) 
	       {  fprintf(list_fich,"    dif =");
	          put_dif(*l_dif, list_fich);
	          }
          free(mem);
          fclose (dif_fich);
          pop_err_msg();
          return(*l_dif);
          };
        n_dif--;
        } while (!feof(dif_fich));
    free(mem);
	 fclose (dif_fich);
    tst_abort (fatal,"No Dif : %s in file %s",modele,filename);
    pop_err_msg();
    return(NULL);
    }

/* ------------------------------------------------------------------ */

TYPE_ANODAT *get_adif (P_(char *) modele)
#ifdef NO_PROTO
char *modele;
#endif
{   int i;

    strup(modele);
    for (i=0;i<lect->nl_ano;i++)
       if (strcmp(lect->anodat[i]->nom,modele)==0)  return(lect->anodat[i]);
       return(NULL);
    }

/* ------------------------------------------------------------------ */

void lecture_ano(P_(void))
{   int i,j;
    char nom[8];
    int tot;
    TYPE_ANODAT *val;
    float *coef;
    lect->anodat = (TYPE_ANODAT **) tst_alloc (lect->nl_ano, sizeof(TYPE_ANODAT *), "anomal");
    for (i=0;i<lect->nl_ano;i++)
    {   fscanf (coord_fich," %s%d",nom,&tot);
        if (lect->prt_dif)    fprintf (list_fich," anomalous f' and f\" : %s for %d wavelength(s)\n",nom,tot);
        if (prt_new) fprintf (new_fich," %s %d\n",nom,tot);
        val = (TYPE_ANODAT *) tst_alloc (lect->nl_ano,sizeof(TYPE_ANODAT)+3*tot*sizeof(float), "anomal");
    lect->anodat[i] =val;
    strcpy (val->nom,nom);
    val->tot=tot;
    coef = val->coef+3;
    for (j=0; j<tot; j++, coef +=3)
    {    fscanf (coord_fich,"%f%f%f",coef,coef+1,coef+2);
        if (lect->prt_dif) fprintf (list_fich,"  %f  f'= %f +i f\"= %f\n",
            coef[0],coef[1],coef[2]);
        if (prt_new) fprintf (new_fich,"  %f  %f  %f\n",coef[0],
            coef[1],coef[2]);
        }
      if (lect->prt_dif) fprintf (list_fich,"\n");
      if (prt_new) fprintf (new_fich,"\n");
      }
    }
/* ------------------------------------------------------------------ */


