static char *cvs_id =" $Id: xnd_keys.c,v 1.4 2004/07/30 08:04:54 berar Exp $ ";
/* XND_keys.c    procedures to handle data with keys */

#define USE_VAR
#define USE_KEYS
#include "../xnd_def.h"
#include "../read/xnd_rdh.h"
#ifndef NO_PROTO
#include <stdarg.h>
#else
#include <varargs.h>
#endif
/* ------------------------------------------------------------------ */
key_mode_type key_mode = STD_KEY;
/* ------------------------------------------------------------------ */
/* get_keys use the following input structure                         */
/* get_keys( "KEY_NAME", "NEXT_KEY" or NULL,                          */
/*           "NAME_0", TYPE_INT,    &value_0,  def_value_0,           */
/*           "NAME_1", TYPE_other,  &value_1, &def_value_1,           */
/*           ...                                                      */
/*	     NULL )                                                   */
/* returns -1 if the key is not seen or the number of values founds   */
/* ------------------------------------------------------------------ */
#ifndef NO_PROTO
#define VA_START  va_start (argptr, next_key);
int get_keys( char * key, char * next_key, ...)
{  va_list argptr;
#else
#define VA_START	va_start (argptr);
int get_keys( key, next_key, va_alist )
char * key;
char * next_key;
va_dcl
{   va_list argptr;
#endif

   char  *c, *d, *e, buffer[252],b[2];
   char  *key_name;
   int    key_type;
   void  *key_value;
   int   *key_int;
   float *key_float;
   float *def_float;
   int   n = -1;
   int   finish = 0;
   int found;
	int query = 0;
	int is_quoted;
   long  filepos;
   push_err_msg("get_keys(xnd_key.c)");
   push_err_msg(key);
   VA_START
   key_name = va_arg ( argptr, char *);
   while ( key_name )
   {  key_type = va_arg ( argptr, int);
      key_value = va_arg ( argptr, void *);
		switch (key_type)
		{  case KEYTYPE_INT :
		      key_int = (int *) key_value;
			   *key_int = va_arg ( argptr, int);
	         break;
		   case KEYTYPE_FLOAT :
		      key_float = (float *) key_value;
		      def_float = va_arg ( argptr, float *);
				if (def_float) *key_float = *def_float;
			   break;
		   case KEYTYPE_STRING:
		   case KEYTYPE_CHAR:
		      c =  va_arg ( argptr, char *);
				if (c )strcpy( key_value, c);
				break;
		   default :
	       termine(16, "unexpected type1 in get_keys(xnd_key.c), please report!");
		   }
		key_name = va_arg ( argptr, char *);
	   }  /* while key_name */
	va_end (argptr);
   purge_cr();
   buffer[0]=0;
   filepos = ftell(coord_fich);
   if ( fscanf(coord_fich, " %[@]", b) == 0 )
   {	 pop_err_msg(); pop_err_msg();
	    return n;
       }
   buffer[0]=0;
   do
   {  fgets(buffer, 250, coord_fich);
      c = strtok ( buffer, " \n\r");
      if (c == NULL) break;
	   if (*c == '?') {  c++; query++; }
		if ( strcmp(c, key) ) 
	   {  if (n==-1)
	   	{  if ( ! next_key ) verbose_printf(" no key %s\n", key);
			   else if ( strcmp(c, next_key)) verbose_printf("  unexpected key %s != %s\n", c, key);
				}
         fseek(coord_fich, filepos, 0);
	      pop_err_msg(); pop_err_msg();
	      return n;
	      }
      if (query)
	   {  verbose_printf ("\n Query mode for key '%s' :\n", key);
		   VA_START
         key_name = va_arg ( argptr, char *);
         while ( key_name )
	      {  key_type = va_arg ( argptr, int);
            key_value = va_arg ( argptr, void *);
		      switch (key_type)
		      {  case KEYTYPE_INT :
		            key_int = (int *) key_value;
						va_arg ( argptr, int);
						verbose_printf(" token '%s' = %d \n", key_name, *key_int);
	               break;
		         case KEYTYPE_FLOAT :
		            key_float = (float *) key_value;
						def_float = va_arg ( argptr, float *);
						verbose_printf(" token '%s' = %f %s initialised\n", key_name, *key_float, def_float==NULL?"not":"");
			         break;
		         case KEYTYPE_STRING:
		         case KEYTYPE_CHAR:
		            c =  va_arg ( argptr, char *);
						verbose_printf(" token '%s' = '%s' %s initialised\n", key_name, key_value, c==NULL?"not":"");
			         break;
		         }
		      key_name = va_arg ( argptr, char *);
	         }  /* while key_name */
	      va_end (argptr);
			}  /* query */
	   if (n>0) fprintf(list_fich,  "%s%-10s", "      ", " ");
	   else
	   {   fprintf(list_fich,"\n%s%-10s", " key @", key);
          n = 0;
	       }
	   c = strtok(NULL, "=");
      while ( c && *c )
	   {  found = 0;
         while (*c == ' ') c++;
         if (*c == '\n' || *c == '\r' ) break;
			d = c;
	      while (*d && *d != ' ') d++;
	      *d=0;
			VA_START
         key_name = va_arg ( argptr, char *);
         while ( key_name && !found )
	      {  key_type = va_arg ( argptr, int);
            key_value = va_arg ( argptr, void *);
	         if ( strcmp(key_name, c ) == 0 )
	         {  found++; n++;
		      	switch (key_type)
		      	{  case KEYTYPE_INT :
		      			c = strtok(NULL, ";\n\r");
		      			key_int = (int *) key_value;
		    	   		sscanf(c, "%d", key_int);
		    	   		fprintf(list_fich, " %s = %d ;", key_name, *key_int);
		    	   		e = NULL;
                     break;
		      		case KEYTYPE_FLOAT :
		      			c = strtok(NULL, ";\n\r");
		      			key_float = (float *) key_value;
		      			sscanf(c, "%f", key_float);
		    	   		fprintf(list_fich, " %s = %f ;", key_name, *key_float);
		    	   		e = NULL;
                     break;
		      		case KEYTYPE_CHAR:
		      			c = strtok(NULL, ";\n\r");
		      			sscanf(c, " %s", key_value);
		    	   		fprintf(list_fich, " %s = '%s' ;", key_name, key_value);
		    	   		e = NULL;
                     break;
		      		case KEYTYPE_STRING:  /* quoted or not */
							c = strtok(NULL, "");
							while (*c == ' ' ) c++;
                     if (*c == '\'' )         /* quoted string */
                     {  c++;
							   c = strtok(c, "'");
		      			   strcpy( key_value, c);
							   c = strtok(NULL, "");   /* in case "';" */
                        while (*c == ';' || *c == ' '|| *c == '\n'|| *c == '\r') c++;
                        e = c;
                        }
							else
							{   c = strtok(c, "\n\r");
		      			    d = ( strlen(c)) ? c + strlen(c)-1 : NULL ;
							    while ( d != c && d != NULL && ( *d == ' ' || *d == '\t' || *d == '\r' || *d == '\n')) d--;
							    if ( d != NULL ) *(++d) = 0;
		      			    strcpy( key_value, c);
                         e = NULL;
                         }
							fprintf(list_fich, " %s = '%s' ;", key_name, key_value);
		    	   		break;
		      		default :
		      			termine(16, "unexpected type2 in get_keys(xnd_key.c), please report!");
		      		}
		         }
		      else switch (key_type)
		      {  case KEYTYPE_INT : va_arg ( argptr, int);
		    	   		break;
		      	case KEYTYPE_FLOAT : va_arg ( argptr, float *);
		    	   		break;
		      	case KEYTYPE_STRING:
		      	case KEYTYPE_CHAR: va_arg ( argptr, char *);
		    	   		break;
		      	default :
		      			termine(16, "unexpected type2 in get_keys(xnd_key.c), please report!");
		      	}
            key_name = va_arg ( argptr, char *);
	         }  /* while key_name */
	    va_end (argptr);
		 if ( !found && (*c != '\n' || *c != '\r'))
		 {  d = strtok(NULL, ";\n\r");
			    verbose_printf("\n key_word '%s' with value '%s' not recognised in key @%s\n",
				   c, d, key);
		    e = NULL;
          }
	    c = strtok(e, "=");
	    }
     fprintf(list_fich, "\n");
     *b=0;
     if (feof(coord_fich)) break;
     filepos = ftell(coord_fich);
     *b=getc(coord_fich);
     }  while (*b == '@' );
   if ( *b && *b != '@') ungetc(*b, coord_fich);
   pop_err_msg();
   pop_err_msg();
	return n;
   }
/* ------------------------------------------------------------------ */
/* new_keys use the following input structure                         */
/* new_keys( "KEY_NAME",                          */
/*           "NAME_0", TYPE_INT,   MODE, value_0, def_value_0,        */
/*           "NAME_1", TYPE_Other, MODE, &value_1, &def_value_1,      */
/*           ...                                                      */
/*			    NULL )                                                   */
/* returns -1 if the key is not writen or the number of values writen */
/* ------------------------------------------------------------------ */
#ifndef NO_PROTO
int new_keys( char *key, ...)
{   va_list argptr;
#else
int new_keys( key, va_alist )
char * key;
va_dcl
{   va_list argptr;
#endif

    char  *c, *d, buffer[102], beg_line[20];
    char  *key_name;
    int    key_type;
    key_mode_type put_mode;
    int   key_int, def_int;
    float *key_float, *def_float;
	 char  *key_str, *def_str;
    int   n, m;
    int found;
    long  filepos;
    
   push_err_msg("new_keys(xnd_key.c)");
   push_err_msg(key);
    if ( key_mode == NO_KEY ) return -1;
    n = m = 0;
	 key_type = KEYTYPE_INT;
#ifndef NO_PROTO
    va_start (argptr, key);
#else
    va_start (argptr);
#endif
   key_name = va_arg (argptr, char *);
	fprintf(new_fich,"\n@%s  ", key);
	strcpy( beg_line,"");
   while ( key_name  )
   {  if ( n )
	   {  if ( m%4 ==0 ) sprintf(beg_line,"\n@%s  ", key);
		   else strcpy( beg_line," ; ");
			}
      key_type = va_arg (argptr, int);
      put_mode = ( key_mode_type ) va_arg (argptr, int);
	   switch (key_type)
	   {  case KEYTYPE_INT :
            key_int   = va_arg ( argptr, int );
            def_int   = va_arg ( argptr, int );
            if ( key_int == def_int && put_mode > key_mode ) break;
		      n++; m++;
				fprintf(new_fich, "%s%s = %d", beg_line, key_name, key_int);
		      break;
	      case KEYTYPE_FLOAT :
            key_float = va_arg ( argptr, float *);
            def_float = va_arg ( argptr, float *);
            if ( key_float == NULL || def_float == NULL) break;
            if ( *key_float == *def_float && put_mode > key_mode ) break;
		      n++; m++;
				fprintf(new_fich, "%s%s = %f", beg_line, key_name, *key_float);
		      break;
	      case KEYTYPE_CHAR:
            key_str = (char *) va_arg ( argptr, char * );
            def_str = (char *) va_arg ( argptr, char * );
            if ( key_str == NULL || def_str == NULL) break;
				if ( strcmp(def_str,key_str) == 0 && put_mode > key_mode ) break;
		      n++; m++;
				fprintf(new_fich, "%s%s = %s", beg_line, key_name, key_str);
		      break;
	      case KEYTYPE_STRING:
            key_str = (char *) va_arg ( argptr, char * );
            def_str = (char *) va_arg ( argptr, char * );
            if ( key_str == NULL || def_str == NULL) break;
            if ( strcmp(def_str,key_str) == 0 && put_mode > key_mode ) break;
		      n++;
				if (strchr(key_str,'\'') == 0 )
				{  fprintf(new_fich, "%s%s = '%s'", beg_line, key_name, key_str, key);
				   if (strlen(key_str)>40) m=0; else m++;
					}
				else
				{  m=0;
				   fprintf(new_fich, "%s%s = %s", beg_line, key_name, key_str, key);
					}
		      break;
	      default :
	         termine(16, "unexpected type in new_keys(xnd_keys.c), please report!");
	      }
      key_name = va_arg ( argptr, char *);
	   }  /* while key_name */
    va_end (argptr);
    fprintf(new_fich, "\n");
	 pop_err_msg();
	 pop_err_msg();
    return n;
    }
/* ------------------------------------------------------------------ */

