/* $Id: xnd_cah.h,v 1.4 2006/04/13 10:10:54 berar Exp $ */
/*  XND_CAH.H  header for XND_CALcul, _RESidual, _PROfil, _HKL and _BACK modules */

		   /* scale factors */
EXTERN float  echelle, exper_echelle, phase_echelle;

		   /* diag actual parameters */
EXTERN int    i_lambda, i_eclair;
EXTERN int    dim_bragg;
EXTERN float  temp_exper;
EXTERN float  minimum;
EXTERN float  diag_p0, diag_pn;
EXTERN float  q_min,q_max;
EXTERN float  t_min,t_max;
EXTERN float  lambda, zero, centrage, eclair, polar;

 				   /* phase */
EXTERN int    i_intens;
EXTERN int    deriv_atom;
EXTERN int    t_bragg,n_bragg,m_bragg;  /* total, non neglig, effect */
EXTERN int    org_orien;   /*current origine in orien functions */
EXTERN float  *d_echelle;
EXTERN float  cell_volume;
EXTERN float  bg;
EXTERN float  *orien_val, *orien_prof;

				    /* raie */
EXTERN float  influence;
EXTERN float  s;
EXTERN float  sin_t, cos_t;
EXTERN float  tan2, cotan_2t, sin_2t, cos_2t, cos2_2t, sin2_t, tan_tm;
EXTERN float  x_orien, y_orien, z_orien;
EXTERN float  *fab_deriv[2], *fabm_deriv[2];
EXTERN float  *vector_deriv;
EXTERN float  t_asym, sin_a, sin_b, dcor_asym, dpro_asym;
EXTERN float  abs_cyl, abs_pl;
EXTERN float  fhkl_2;
EXTERN float  phase_wg, phase_wl;
EXTERN float  sign_onde, sign_instru0, sign_instru2, sign_phase;
EXTERN int    first_point;
				/* point */
EXTERN float  dt;
EXTERN float  d_p_t,d_p_l,d_p_g;
EXTERN float  *d_p_a;
EXTERN float  dd_p_ll, dd_p_gg, dd_p_lg;
EXTERN float  d_pa_ins[2];            /* asym deriv for convol */
           /* modes */
EXTERN int do_derivatives;
EXTERN int do_plg_data;
EXTERN int do_listing;

/*         prototype des fonctions                */
/*  --------------------------------------------- */
/*  indirect functions     at program level       */
EXTERN void  (*back_ground)  PROTO((void));
/*  indirect functions     at experiment level    */
EXTERN float (*valdif)       PROTO((void));
/*  indirect functions     at phase level         */
EXTERN int   (*fhkl_eff)     PROTO((int pos));
EXTERN float (*fhkl_sum)     PROTO((void));
EXTERN void  (*hkl_eff)      PROTO((void));
EXTERN void  (*gen_holoedre) PROTO((void));
EXTERN void  (*genget_hkl)   PROTO((void));
EXTERN int   (*multiplicity) PROTO((void));
EXTERN int   (*extinction)   PROTO((void));
/*  --------------------------------------------- */
/* in XND_DER.C  derivatives calculations */
int profil_point PROTO((int pos));
/*  --------------------------------------------- */
/* in XND_RES.C  residual calculations */
void  residu PROTO(( void));
/*  --------------------------------------------- */
/* in XND_CAL.C  pattern calculations */
void  traite_hkl PROTO(( void ));
float f_echelle PROTO(( int i, float *d) );
/*  --------------------------------------------- */
/* in XND_PRO.C  profil functions */
int  def_profil PROTO((void));
int  ini_profil PROTO((void));
float profil    PROTO((void));
void d_pil   PROTO((void));
/*  --------------------------------------------- */
/* in XND_BAC.C  the back_ground functions */
void inter_back  PROTO((void));
void spline_back PROTO((void));
void ini_back_ground PROTO((void));
/*  --------------------------------------------- */
/* in XND_BLK.C  preparation des blocs rigides    */
void ini_blk PROTO((int print_code));
void free_blk PROTO((void));
/*  --------------------------------------------- */
/* in XND_DIF.C :       redirection by valdif ... */
float x_valdif PROTO((void));
float b_valdif PROTO((void));
float ux_valdif PROTO((void));
float ub_valdif PROTO((void));
float mb_valdif PROTO((void));

void  ini_anodif PROTO((void));
float anodif PROTO((void));
float anodif_b PROTO((void));
float magdif PROTO((void));
/*  --------------------------------------------- */
/* in XND_COR.C : orientation, LP_cor             */
float f_orien PROTO((int n, int cas, float coef));
void ini_orientation PROTO((void));
void orientation PROTO((void));
void valcor PROTO((void));
/*  --------------------------------------------- */
/* in XND_MET.C : metric                          */
float ini_metric PROTO((void));
void  ini_d_metric PROTO((void));
float scalaire PROTO((float *u, float *gv, float *v));
float d_dmetric PROTO((int j, float *u, float *v));
/*  --------------------------------------------- */
/* in XND_UNC.C : uncoherent, diffuse...     */
void  gen_uncoherent  PROTO((void));
void  gen_tds     PROTO((void));
void  gen_tds_hkl PROTO((void));
/*  --------------------------------------------- */
/* in XND_DEB.C : debye factors and anharmonic exp */
float debye_0 PROTO((float b_iso));
float debye_2 PROTO((float *b_ij, float *h_sym, float *hk_sym));
float anharm_3 PROTO((float *b_c, float *h_sym, float *hk_c));
float anharm_4 PROTO((float *b_d, float *h_sym, float *hk_d));
float anharm_5 PROTO((float *b_e, float *h_sym, float *hk_e));
float anharm_6 PROTO((float *b_f, float *h_sym, float *hk_f));
/*  --------------------------------------------- */
/* in XND_HKL.C :  structure factors, gen hkl     */
int  fhkl_atom PROTO((int pos));
/*  --------------------------------------------- */
/* in XND_INC.C : incomensurate modulated structure factors */
int  fhkl_incmod PROTO((int pos));     
/*  --------------------------------------------- */
/* in XND_COM.C : comensurate modulated structure factors */
 int  fhkl_commod PROTO((int pos));
/*  --------------------------------------------- */

