/* $Id: xnd_fun.h,v 1.3 2006/04/13 10:11:23 berar Exp $ */
/*   XND_FUN.H            prototype des fonctions generales */
/*             d'autres declarations sont dans rdh ou cah   */
/*  ------------------------------------------------------- */
/*  in XND_MAIN.C */

void termine    PROTO((int cas, char *msg));
FILE * xclose PROTO(( FILE *file));
/*  --------------------------------------------- */
/* in XND_RDI.C ( + XND_RSYM ) */

void   fprint_xyz_pos PROTO((FILE *file, float *l_coef, char end_char));
void   read_init      PROTO((int argn, char **argv));
sint   read_remark    PROTO((char **remptr));

/*  --------------------------------------------- */
/* in XND_PRT.C output  parameters */
void write_remark PROTO((sint nombre));
void imprime     PROTO((int do_print, int auto_intensity, int saving));
void prt_u_equiv PROTO((void));
void prt_correl  PROTO((void));

/*  --------------------------------------------- */
/* in XND_NEW.C  new_file with the values of parameters */

void   new_cdr    PROTO((void));

/*  --------------------------------------------- */
/*  --------------------------------------------- */
/* in XND_HKL.C : find Bragg lines, corection and structure factors */

void  make_hkl  PROTO((int iphase));
int  exist_hkl    PROTO((int ihkl));
void gen_sym_related PROTO((void));
/*  --------------------------------------------- */
/* in XND_MOD.C :  modulated hkl */
void ini_d_vector  PROTO((float dt_dq));

/*  --------------------------------------------- */
/* in XND_COR.C :  correction and structure factors */

void  p_orien  PROTO((int n, int cas));

/*  --------------------------------------------- */
/* in XND_AMO.C : intensities for amorphous phases */

void  int_rdfpeak PROTO((void));
void  int_amorphe PROTO((void));
/*  --------------------------------------------- */
/* in XND_RAD.C : intensities for radial distrib */

void  int_radist PROTO((void));

/*  --------------------------------------------- */
/* in XND_PEN.C  restraint on bonds or angles */

ATOM_PTR   atom_ptr PROTO((int num));
float   penal     PROTO((void));

/*  --------------------------------------------- */
/*   in XND_MET.C */
/* metric calculation */
float ini_metric PROTO((void));
#ifdef NO_PROTO
float u_equiv  ();
#else
float u_equiv  (VAR_PTR u, float *uij);
#endif
/*  --------------------------------------------- */
/* in XND_MAT.C */

void   inverse  PROTO((float ratio));
int chol_part   PROTO((FLOAT *mat, FLOAT *vect, int n));
float poly_f    PROTO((float *x, int deg, float *coef));
float sqr       PROTO((float x));
float fsrand    PROTO((void));

float tab_exp   PROTO((float x));
float tab_sin   PROTO((float x));
float tab_cos   PROTO((float x));

/* and  int matherr... a modified handler to be used with some compilers */


/*  --------------------------------------------- */
/*  --------------------------------------------- */
/*   in XND_USE.C */
/*  ---------------------- */
void chk_abort   PROTO((char *format, ...));
void tst_abort   PROTO((int test, char *format, ...));
void *tst_alloc  PROTO((int nb, int size, char *name));
char *str_alloc  PROTO((char *content));
FILE *tst_open   PROTO((char *name, char *mode, char *msg));
int  verbose_printf PROTO((char *format, ...));

/*  --------------------------------------------- */
/*   in XND_SIG.C */
void init_error PROTO((void));

void clear_err_msg PROTO((void));
int push_err_msg PROTO((char *msg));
void pop_err_msg PROTO((void));
void set_err_msg PROTO((int n));
void dump_err_msg PROTO((void));
/*  --------------------------------------------- */
/*   in XND_PRO.C */
void init_asym_function PROTO((void));
void ini_asym_tables PROTO((void));
/*  --------------------------------------------- */
/*   in XND_MAG.C   used also in xnd_rcry.c       */
float *nucl_sym PROTO((int nmag, SYMGRP_PTR m_symgrp));
/*  --------------------------------------------- */
