/* $Id: xnd_t_keys.h,v 1.2 2006/04/13 10:12:33 berar Exp $ */
/* xnd_t_keys.h    header for keys usage           */
/* --------------------------------------------- */
#ifndef  XND_T_KEYS_H_INCLUDED  /* included once only */
#define  XND_T_KEYS_H_INCLUDED

/* this file contains all the default values */
/* used for the variables initialization     */
/* it uses uppercase name for each variable  */

int get_keys PROTO(( char * key, char * next_key, ...));
/* ------------------------------------------------------------------ */
/* get_keys use the following input structure                         */
/* get_keys( "KEY_NAME", "NEXT_KEY" or NULL,                          */
/*           "NAME_0", TYPE_INT,   &value_0, def_value_0, 	      	 */
/*           "NAME_1", TYPE_Other, &value_1, &def_value_1,     	    */
/*           ...                                                      */
/*			    NULL )                                                   */
/* returns -1 if the key is not seen or the number of values founds   */
/* ------------------------------------------------------------------ */
int new_keys PROTO(( char * key,  ...));
/* ------------------------------------------------------------------ */
/* new_keys use the following input structure                         */
/* new_keys( "KEY_NAME",                           */
/*           "NAME_0", TYPE_INT,   MODE, value_0,  def_value_0,       */
/*           "NAME_1", TYPE_Other, MODE, &value_1, &def_value_1,      */
/*           ...                                                      */
/*			    NULL )                                                   */
/* returns -1 if the key is not writen or the number of values writen */
/* ------------------------------------------------------------------ */

typedef enum { NO_KEY=-1, FEW_KEY, STD_KEY, EXT_KEY, ALL_KEY } key_mode_type;
extern key_mode_type key_mode;


#define KEYTYPE_INT    0        /* used for integer type */
#define KEYTYPE_FLOAT  1        /* used for float type */
#define KEYTYPE_STRING 2        /* used for allocated chars up to line end*/
#define KEYTYPE_CHAR   3        /* used for allocated chars */

/* global variable defined by key with non zero (or obvious) default value */
#define KEY_XND_EXPER      1
#define KEY_XND_PHASE      1
#define KEY_XND_CYCLE     10

#define KEY_MODES_ASYM    2
#define KEY_MODES_ORDER    1
#define KEY_MODES_STOP     0.1
#define KEY_MODES_PROF     0.1
#define KEY_MODES_RELAX    0.85

#define KEY_TEST_REPART 0.5
#define KEY_TEST_RMIN   0.125
#define KEY_TEST_RMAX   0.125
#define KEY_TEST_RESOL  30
#define KEY_TEST_WIDTH  5

/* default values for VARIABLE reads */
#define VAR_ORDER  1
#define VAR_ORDER_KEYMODE   ALL_KEY
#define VAR_DIM   1
#define VAR_DIM_KEYMODE    ALL_KEY

/* default values for EXPERIMENT structures */
#define KEY_EXPER_NATURE  0
#define KEY_EXPER_TECHN   0
#define KEY_EXPER_DATA    1
#define KEY_EXPER_FILE    1
#define KEY_EXPER_LAMBDA  1
#define KEY_EXPER_BGROUND 2
#define KEY_EXPER_ALIMIT  0
#define KEY_EXPER_ORIG    0.0
#define KEY_EXPER_WEIGHT  1.0
#define KEY_DATA_START   10.0
#define KEY_DATA_STOP    60.0
#define KEY_DATA_STEP     0.1


/* default values for PHASE structures */
#define KEY_PHASE_NATURE  0
#define KEY_PHASE_TRANSIT 0
#define KEY_PHASE_ORIG    0.0
#define KEY_CRYST_ATOM    1

#define KEY_MODUL_ORDER  -25
#define KEY_MODUL_SATEL    2

/* --------------------------------------------- */
#endif          /*  XND_T_KEYS_H_INCLUDED        */
/* --------------------------------------------- */

