/* $Id: xnd_t_var.h,v 1.2 2004/07/30 08:05:23 berar Exp $ */
/* xnd_t_var.h    header for var usage           */
/* --------------------------------------------- */
#ifndef  XND_T_VAR_H_INCLUDED  /* included once only */
#define  XND_T_VAR_H_INCLUDED
/* --------------------------------------------- */
#define VAR_MODE_STD 0
#define VAR_MODE_GT0 1
#define VAR_MODE_ABS 2
#define VAR_MODE_OCC 4
#define VAR_MODE_COR 8
/* --------------------------------------------- */
typedef struct
{  int     number;
   int     ncle;
   int     argtype;   /* selon constantes VAR_ de xnd_vdef.h */
   int     order;
   int     dim;
   int     npar;
   int     remark;
	int     mode;
	float   relax;             /* override if non zero */
	float   allow_shift;       /* if non 0 */
   float   *value;
   float   *saved;
   float   *shift;
   int     *codelu;
   int     *param;
   char    *nature;
   void    *link;
   void    **cle;
   }       TYPE_VAR;
/* --------------------------------------------- */
extern TYPE_VAR * current_var;  /* current variable */
extern int  do_save;          /* allow to save current values */
/* --------------------------------------------- */
/* values of the current variable                */
extern int    var_order;
extern int    var_dim;
extern int    var_number;
extern int    var_io;
extern int    var_id;
/* associated macros*/
#define VAR_io_id  for (var_io=0;var_io<var_order;var_io++) for(var_id=0;var_id<var_dim;var_id++)
#define VAR_iod    iod = var_io*var_dim+var_id
/*  --------------------------------------------- */
/*   XND_VAR.C     variable expansion             */
/* replace VAR_init macro */
TYPE_VAR *var_init    PROTO((TYPE_VAR* var));
int   var_ideriv  PROTO((TYPE_VAR* var));   /* similar to VAR_init  */
float var_valeur  PROTO((int pos));
int   var_param   PROTO((int pos));
float var_derive  PROTO((void));
float var_shift   PROTO((void));
float var_new     PROTO((float *deplac));
float var_allowed PROTO((float deplace, int * code));
/*  --------------------------------------------- */
/*   XND_VIO.C     input, output                  */
char * var_set_name PROTO((TYPE_VAR * var, char * name));
void   var_set_value(TYPE_VAR *var, int pos, float value);
void * var_get_link  PROTO((TYPE_VAR * var));
TYPE_VAR * fget_var  PROTO((int nombre,int ncle, int arg, char *nature, void **cle, char *keyname,\
          int *nb_ptr, int mode, float allow_shift));
void fnew_var  PROTO((TYPE_VAR *var, char* keyname));
int  var_fput   PROTO((TYPE_VAR *var));
int  var_check  PROTO((TYPE_VAR *var));
TYPE_VAR * var_alloc (int number, int arg); /* only for hkl */
int   var_par_set(TYPE_VAR *var, int b, int e, int c);
void  var_adjust(TYPE_VAR *var, int number);
void  var_init_loop(int saving, int print, int loop_nb);
void	var_end_loop();
void  var_init_mode( int var_mask);
/* --------------------------------------------- */
#define VAR_STD    0
#define VAR_FLOAT  1
#define VAR_ATOM   2
#define VAR_ORIEN  3
#define VAR_HKL    4
#define VAR_POLY   5
#define VAR_ANHARM 6
/* --------------------------------------------- */
#endif          /*  XND_T_VAR_H_INCLUDED        */
/* --------------------------------------------- */
